﻿using System.Collections;
using Utilities;
using WeifenLuo.WinFormsUI.Docking;

namespace SmartCard_Suite_2_0
{
    public class AppExplorer : IPlugin
    {
        private string _pluginName = "Application Explorer";

        private string _description = "Opis";

        private string _author = "Julia Graczyk Krzysztof Sypniewski";

        private string _version = "Wersja";

        private string _date = "Data wydania";

        private AppExplorerForm _pluginForm;

        private IMainApplication _application;

        #region Implementation of IPlugin

        public string PluginName
        {
            get { return _pluginName; }
        }

        public string Description
        {
            get { return _description; }
        }

        public string Author
        {
            get { return _author; }
        }

        public string Version
        {
            get { return _version; }
        }

        public string Date
        {
            get { return _date; }
        }

        public DockContent PluginForm
        {
            get { return _pluginForm; }
        }

        public IMainApplication application
        {
            get { return _application; }
        }

        public Hashtable Exec(string command, Hashtable parameters)
        {
            return null;
        }

        public void PluginLoad(Hashtable initializationParameters)
        {
            _application = (IMainApplication)initializationParameters["MainForm"];
        }

        public void PluginUnLoad(Hashtable parameters)
        {
            _pluginForm = null;
        }

        public void CreatePluginForm(bool force = false)
        {
            if ((_pluginForm == null) || (force))
                _pluginForm = new AppExplorerForm(this);
        }

        #endregion

        public override string ToString()
        {
            return PluginName + " (v. " + Version + ")";
        }
    }
}
