﻿using System;
using System.Data;
using System.Collections;
using System.Drawing;
using System.Windows.Forms;
using Utilities;
using WeifenLuo.WinFormsUI.Docking;
using System.Collections.Generic;

namespace SmartCard_Suite_2_0
{
    public partial class AppExplorerForm : DockContent
    {
        public IPlugin mainclass;
        public ByteArray Error;

        public AppExplorerForm(IPlugin plugin)
        {
            InitializeComponent();
            mainclass = plugin;
            Error = new ByteArray("9999");
        }

        private void button1_Click(object sender, System.EventArgs e)
        {
            var cardManagerExpr = "CardManager = True";
            var applicationExpr = "CardManager = False";
            DataRow[] cardManager = this.databaseDataSet.AID_Table.Select(cardManagerExpr);
            DataRow[] application = this.databaseDataSet.AID_Table.Select(applicationExpr);


            label1.Text = "Trwa wyszukiwanie. Proszę czekać...";
            label1.Refresh();
            foreach (DataRow app in application)
            {
                
                ByteArray AID = new ByteArray(app["ApplicationIdentifier"].ToString());
                ByteArray response = SelectDF(AID);
                if (!response.Equals(Error))
                {
                    textBox1.AppendText("Name: " + app["Name"].ToString() + " Vendor: " + app["Vendor"].ToString() + " Country: " + app["Country"].ToString() + " Description: " + app["Description"].ToString() + "\r\n");
                }
            }
            foreach (DataRow manager in cardManager)
            {
                ByteArray AID = new ByteArray(manager["ApplicationIdentifier"].ToString());
                ByteArray response = SelectDF(AID);
                if (!response.Equals(Error))
                {
                    foreach (DataRow app in application)
                    {
                        AID = new ByteArray(app["ApplicationIdentifier"].ToString());
                        response = SelectDF(AID);
                        if (!response.Equals(Error))
                        {
                            textBox1.AppendText("Name: " + app["Name"].ToString() + " Vendor: " + app["Vendor"].ToString() + " Country: " + app["Country"].ToString() + " Description: " + app["Description"].ToString() + "\r\n");
                        }

                    }
                    textBox1.AppendText("Name: " + manager["Name"].ToString() + " Vendor: " + manager["Vendor"].ToString() + " Country: " + manager["Country"].ToString() + " Description: " + manager["Description"].ToString() + "\r\n");
                }
            }
          

            label1.Text = "Zakończono wyszukiwanie.";
            label1.Refresh();
            

        }
        public ByteArray SelectDF(ByteArray AID)
        {
            if (AID == null || AID.Length == 0)
            {
                try
                {
                    return mainclass.application.Encoder.SendCommand(new ByteArray("00 a4 04 00") );
                }
                catch (Exception exception)
                {
                    try
                    {
                        return mainclass.application.Encoder.SendCommand(new ByteArray("00 a4 04 04") );
                    }
                    catch (Exception excep)
                    {
                        return Error;
                    }
                }
            }
            
            try
            {
                return mainclass.application.Encoder.SendCommand(new ByteArray("00 a4 04 00") + (byte)AID.Length + AID + 0x00);
            }
            catch (Exception exception)
            {
                try
                {
                    return mainclass.application.Encoder.SendCommand(new ByteArray("00 a4 04 04") + (byte)AID.Length + AID + 0x00);
                }
                catch(Exception excep)
                {
                    return Error;
                }
            }
        }

        private void aID_TableBindingNavigatorSaveItem_Click(object sender, EventArgs e)
        {
            this.Validate();
            this.aID_TableBindingSource.EndEdit();
            this.tableAdapterManager.UpdateAll(this.databaseDataSet);

        }

        private void AppExplorerForm_Load(object sender, EventArgs e)
        {
            // TODO: This line of code loads data into the 'databaseDataSet.AID_Table' table. You can move, or remove it, as needed.
            this.aID_TableTableAdapter.Fill(this.databaseDataSet.AID_Table);

        }

        

        
    }
}